﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectMotorboat
{
    public partial class FormMotorboat : Form
    {
        private DrawningMotorboat? _drawningMotorboat;
        public FormMotorboat()
        {
            InitializeComponent();
        }

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawningMotorboat = new DrawningMotorboat();
            _drawningMotorboat.Init(random.Next(100, 300), random.Next(1000, 3000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
            _drawningMotorboat.SetPictureSize(pictureBoxMotorboat.Width, pictureBoxMotorboat.Height);
            _drawningMotorboat.SetPosition(random.Next(10, 100), random.Next(10, 100));

            Bitmap bmp = new(pictureBoxMotorboat.Width, pictureBoxMotorboat.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningMotorboat.DrawTransport(gr);
            pictureBoxMotorboat.Image = bmp;
        }

        private void Draw()
        {
            if (_drawningMotorboat == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxMotorboat.Width,
            pictureBoxMotorboat.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningMotorboat.DrawTransport(gr);
            pictureBoxMotorboat.Image = bmp;
        }

        /// <summary>
        /// Перемещение объекта по форме (нажатие кнопок навигации)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawningMotorboat == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            bool result = false;
            switch (name)
            {
                case "buttonUp":
                    result = _drawningMotorboat.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    result = _drawningMotorboat.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    result = _drawningMotorboat.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    result = _drawningMotorboat.MoveTransport(DirectionType.Right);
                    break;
            }
            if (result)
            {
                Draw();
            }
        }

        //private void ButtonMove_Click(object sender, MouseEventArgs e)
        //{

        //}
    }
}
